## deepin-calculator 6.5.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9.5)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

#最外层一个工程，单项目中不添加工程，只添加执行文件
project(deepin-calculator)

include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
set(QT_MINIMUM_VERSION "5.7.1")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

#add_definitions(-DQT_NO_DEBUG_OUTPUT)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    message(STATUS "this system is mips64=========")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed")
endif()

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")

    execute_process(COMMAND bash "${CMAKE_CURRENT_LIST_DIR}/translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/)
endif ()

set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

configure_file(src/environments.h.in environments.h @ONLY)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Test REQUIRED)

pkg_search_module(DtkWidget REQUIRED dtkwidget)
pkg_search_module(DtkGui REQUIRED dtkgui)
pkg_search_module(DtkCore REQUIRED dtkcore)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

set (EXE_NAME deepin-calculator)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::Xml
    Qt5::Svg
    Qt5::Test

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
)

file(GLOB_RECURSE CAL_SRCH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)
file(GLOB_RECURSE CAL_SRCC ${CMAKE_CURRENT_LIST_DIR}/src/*.c)
file(GLOB_RECURSE CAL_SRCCPP ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE CAL_3rdH ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.h)
file(GLOB_RECURSE CAL_3rdC ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.c)
file(GLOB_RECURSE CAL_3rdCPP ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.cpp)

set (DC_QRC_FILES
    src/deepin-calculator.qrc
)

add_executable (${EXE_NAME}
    ${CAL_SRCH}
    ${CAL_SRCC}
    ${CAL_SRCCPP}
    ${CAL_3rdH}
    ${CAL_3rdC}
    ${CAL_3rdCPP}
    ${DC_QRC_FILES}
)

target_include_directories(${EXE_NAME} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5TestLib_LIBRARIES}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS})

target_link_libraries (${EXE_NAME} ${LINK_LIBS})

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

install(TARGETS deepin-calculator DESTINATION ${CMAKE_INSTALL_BINDIR})
file(GLOB QM_FILES "${CMAKE_CURRENT_LIST_DIR}/translations/*.qm")
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-calculator/translations)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/deepin-calculator.desktop
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications/)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/src/assets/images/deepin-calculator.svg
            DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/src/assets/deepin-calculator
                DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)

#if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
option (BUILD_TESTING "" ON)
if (BUILD_TESTING)
add_subdirectory(tests)  #tests为ut测试文件夹名
endif ()
endif ()
#endif ()


#代码覆盖率开关
if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

#源程序cmakelists再添加上ut相关环境搭建

cmake_minimum_required(VERSION 3.9.5)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

ADD_COMPILE_OPTIONS(-fno-access-control)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
set(QT_MINIMUM_VERSION "5.7.1")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

#add_definitions(-DQT_NO_DEBUG_OUTPUT)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    message(STATUS "this system is mips64=========")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed")
endif()

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")

    execute_process(COMMAND bash "${CMAKE_CURRENT_LIST_DIR}/../translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/../)
endif ()

configure_file(${CMAKE_CURRENT_LIST_DIR}/../src/environments.h.in environments.h @ONLY)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Test REQUIRED)

find_package(DtkWidget REQUIRED dtkwidget)
find_package(DtkGui REQUIRED dtkgui)
find_package(DtkCore REQUIRED dtkcore)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

pkg_check_modules(GTEST REQUIRED
    gtest
    gmock
    )

set (EXE_NAME deepin-calculator)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::Xml
    Qt5::Svg
    Qt5::Test

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
)

#CMAKE_CURRENT_LIST_DIR缓存文件的目录，头文件找不到问题解决方案1,文件中未使用该头文件变量　2,CMAKE_CURRENT_LIST_DIR改为CMAKE_SOURCE_DIR
SET(HEAD ${CMAKE_CURRENT_LIST_DIR}/../src
         ${CMAKE_CURRENT_LIST_DIR}/../src/bak
         ${CMAKE_CURRENT_LIST_DIR}/../src/control
         ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/core
         ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/math
         ${CMAKE_CURRENT_LIST_DIR}/../src/views
         ${CMAKE_CURRENT_LIST_DIR}/../src/widgets
         )

file(GLOB_RECURSE CAL_H ${CMAKE_CURRENT_LIST_DIR}/../src/*.h)
file(GLOB_RECURSE CAL_C ${CMAKE_CURRENT_LIST_DIR}/../src/*.c)
file(GLOB_RECURSE CAL_CPP ${CMAKE_CURRENT_LIST_DIR}/../src/*.cpp)
file(GLOB_RECURSE CAL_3rdH ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/*.h)
file(GLOB_RECURSE CAL_3rdC ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/*.c)
file(GLOB_RECURSE CAL_3rdCPP ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/*.cpp)
list(REMOVE_ITEM CAL_CPP "${CMAKE_CURRENT_LIST_DIR}/../src/main.cpp")

file(GLOB_RECURSE CAL_TEST ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE CAL_TESTH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)

#find_package(GTest REQUIRED)
include_directories(${GTEST_INCLUDE_DIRS})

set (DC_QRC_FILES
    ${CMAKE_CURRENT_LIST_DIR}/../src/deepin-calculator.qrc
)

set(PROJECT_NAME_TEST
    ${PROJECT_NAME}-test)

# 生成测试可执行程序
add_executable(${PROJECT_NAME_TEST} ${CAL_H} ${CAL_C} ${CAL_CPP} ${CAL_3rdH} ${CAL_3rdC} ${CAL_3rdCPP} ${CAL_TEST} ${CAL_TESTH})

# 生成测试可执行程序的依赖库
target_link_libraries(${PROJECT_NAME_TEST} ${GTEST_LIBRARYS} ${GTEST_MAIN_LIBRARYS} gmock gmock_main gtest gtest_main pthread)

target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5TestLib_LIBRARIES}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS}
                                              ${GTEST_INCLUDE_DIRS}
                                              ${HEAD})
target_link_libraries (${PROJECT_NAME_TEST} ${LINK_LIBS})

#set(CMAKE_INSTALL_PREFIX /usr)
if(DEFINED ENV{PREFIX})
    set(CMAKE_INSTALL_PREFIX $ENV{PREFIX})
else()
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

install(TARGETS deepin-calculator DESTINATION bin)
file(GLOB QM_FILES "${CMAKE_CURRENT_LIST_DIR}/../translations/*.qm")
install(FILES ${QM_FILES} DESTINATION share/deepin-calculator/translations)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/../deepin-calculator.desktop
        DESTINATION share/applications/)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/../src/assets/images/deepin-calculator.svg
            DESTINATION share/icons/hicolor/scalable/apps/)


#------------------------------ 创建'make test'指令---------------------------------------
add_custom_target(test
#    COMMAND mkdir -p tests/coverageResult
#    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

add_custom_command(TARGET test
    COMMAND echo " =================== CREAT LCOV REPROT BEGIN ==================== "

    #1.清理原先的gcov信息
#    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME_TEST}.dir --zerocounters
#    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME}.dir --zerocounters
    COMMAND ${CMAKE_BINARY_DIR}/tests/${PROJECT_NAME_TEST}


    #2.收集gcov信息到.info文件中
#    COMMAND lcov --directory . --capture --output-file ./tests/coverageResult/${PROJECT_NAME}_Coverage.info

    #3.过滤一些我们不感兴趣的文件的覆盖率信息
#    COMMAND echo " =================== do filter begin ==================== "
#    COMMAND lcov --remove ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
#    '*/${PROJECT_NAME_TEST}_autogen/*' '*/${PROJECT_NAME}_autogen/*' '*/tests/*' '*/googletest/*' '*/usr/include/*' '*/src/bak/*' '*/src/core/*' '*/src/math/*'
#    -o ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
#    COMMAND echo " =================== do filter end ==================== "

    #3.将.info信息生成报告到reprot文件夹中
#    COMMAND genhtml -o ./tests/coverageResult/report ./coverageResult/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== CREAT LCOV REPROT END ==================== "

#    COMMAND echo " Coverage files have been output to ${CMAKE_BINARY_DIR}/coverageResult/report "

#    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

#'make test'命令依赖与我们的测试程序
add_dependencies(test ${PROJECT_NAME_TEST})

# 设置添加gocv相关信息的输出
set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

=== debian/changelog ===
deepin-calculator (6.5.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Rebuild against new libdtk.

 -- Boyuan Yang <byang@debian.org>  Tue, 11 Feb 2025 15:51:51 -0500

=== debian/control ===
Source: deepin-calculator
Section: math
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Arun Kumar Pariyar <openarungeek@gmail.com>,
 Tu Qinggang <tuqinggang@uniontech.com>,
 Clay Stan <claystan97@gmail.com>,
 qinxialei <xialeiqin@gmail.com>,
 Nisha Pariyar <nishapariyar48@gmail.com>,
 Raju Devidas <mail@raju.dev>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 lcov,
 libdframeworkdbus-dev (>= 6),
 libdtkgui-dev (>= 5.7.8),
 libdtkwidget-dev (>= 5.7.8),
 libgmock-dev,
 libgtest-dev,
 libqt5svg5-dev,
 pkgconf,
 qtbase5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/linuxdeepin/deepin-calculator
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-calculator.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-calculator

Package: deepin-calculator
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Calculator for DDE (Deepin Desktop Environment)
 An easy to use calculator for ordinary users.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

export DEB_CPPFLAGS_MAINT_APPEND = -Wl,-z,now

export QT_SELECT := 5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DAPP_VERSION=$(DEB_VERSION) -DVERSION=$(DEB_VERSION) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 i386))
override_dh_auto_test:

endif

override_dh_missing:
	dh_missing --fail-missing

## deepin-calculator 6.5.12

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.0)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

#最外层一个工程，单项目中不添加工程，只添加执行文件
project(deepin-calculator)

include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
set(QT_MINIMUM_VERSION "6.0.0")
set(CMAKE_EXE_LINKER_FLAGS "-pie")


# Find the Qt library
find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
message("Using Qt version: ${QT_VERSION_MAJOR}")

#qt5    
#find_package(Qt5 COMPONENTS Core REQUIRED)
# Select major DTK version.
if(QT_VERSION_MAJOR EQUAL "6")
    set(BUILD_WITH_QT6 ON)
    set(DTK_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
endif()
message("Using dtk version: ${DTK_VERSION_MAJOR}")

#add_definitions(-DQT_NO_DEBUG_OUTPUT)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    message(STATUS "this system is mips64=========")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed")
endif()

set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

configure_file(src/environments.h.in environments.h @ONLY)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt6 REQUIRED COMPONENTS Widgets Core Gui DBus Xml Svg Test)

#qt5
#find_package(Qt5 REQUIRED COMPONENTS Widgets Core Gui DBus Xml Svg Test)

# 替换 pkg_search_module 为 find_package
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget Gui Core)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

message(STATUS "DtkGui Include Directories111: ${DtkGui_INCLUDE_DIRS}")
message(STATUS "DtkCore Include Directories11: ${DtkCore_INCLUDE_DIRS}")
message(STATUS "DtkWidget Include Directories111: ${DtkWidget_INCLUDE_DIRS}")

set (EXE_NAME deepin-calculator)

if (Qt6_FOUND)
    # Qt6 environment
    set(LINK_LIBS
    Qt6::Core
    Qt6::DBus
    Qt6::Widgets
    Qt6::Xml
    Qt6::Svg
    Qt6::Test

    Dtk${DTK_VERSION_MAJOR}::Widget
    Dtk${DTK_VERSION_MAJOR}::Gui
    Dtk${DTK_VERSION_MAJOR}::Core
    ${DFrameworkDBus_LIBRARIES}
)
else()
    # Qt5 environment
    set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::Xml
    Qt5::Svg
    Qt5::Test

    Dtk${DTK_VERSION_MAJOR}::Widget
    Dtk${DTK_VERSION_MAJOR}::Gui
    Dtk${DTK_VERSION_MAJOR}::Core
    ${DFrameworkDBus_LIBRARIES}
)
endif()


file(GLOB_RECURSE CAL_SRCH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)
file(GLOB_RECURSE CAL_SRCC ${CMAKE_CURRENT_LIST_DIR}/src/*.c)
file(GLOB_RECURSE CAL_SRCCPP ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE CAL_3rdH ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.h)
file(GLOB_RECURSE CAL_3rdC ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.c)
file(GLOB_RECURSE CAL_3rdCPP ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.cpp)

set (DC_QRC_FILES
    src/deepin-calculator.qrc
)

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")

    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS LinguistTools)
    file(GLOB TS LIST_DIRECTORIES false translations/${CMAKE_PROJECT_NAME}*.ts)
    set_source_files_properties(${TS} PROPERTIES OUTPUT_LOCATION ${PROJECT_SOURCE_DIR}/translations)
    qt_create_translation(QM ${CAL_SRCH} ${CAL_SRCCPP} ${TS})
endif ()

add_executable (${EXE_NAME}
    ${CAL_SRCH}
    ${CAL_SRCC}
    ${CAL_SRCCPP}
    ${CAL_3rdH}
    ${CAL_3rdC}
    ${CAL_3rdCPP}
    ${DC_QRC_FILES}
    ${QM}
)

target_include_directories(${EXE_NAME} PUBLIC ${Qt6Widgets_LIBRARIES}
                                              ${Qt6DBus_LIBRARIES}
                                              ${Qt6TestLib_LIBRARIES}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGui_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS})

target_link_libraries (${EXE_NAME} ${LINK_LIBS})

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

install(TARGETS deepin-calculator DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/translations
    DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-calculator
    FILES_MATCHING PATTERN "*.qm")
install(FILES ${CMAKE_CURRENT_LIST_DIR}/deepin-calculator.desktop
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications/)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/src/assets/images/deepin-calculator.svg
            DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/src/assets/deepin-calculator
                DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)

#if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
# 禁用测试
# if (CMAKE_BUILD_TYPE STREQUAL "Debug")
# option (BUILD_TESTING "" ON)
# if (BUILD_TESTING)
# add_subdirectory(tests)  #tests为ut测试文件夹名
# endif ()
# endif ()
#endif ()

#代码覆盖率开关
if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

=== debian/changelog ===
deepin-calculator (6.5.12) unstable; urgency=medium

  * New version 6.5.12. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Wed, 14 May 2025 11:08:19 +0800

deepin-calculator (6.5.11) unstable; urgency=medium

  * Update translations.

 -- renbin <renbin@uniontech.com>  Thu, 17 Apr 2025 09:38:24 +0800

deepin-calculator (6.5.10) unstable; urgency=medium

  * chore: New version 6.5.10.

 -- xiepengfei <xiepengfei@uniontech.com>  Wed, 02 Apr 2025 15:55:22 +0800

deepin-calculator (6.5.9) unstable; urgency=medium

  *Bump version to 6.5.9 

 -- Wang Yu <wangyu@uniontch.com>  Fri, 07 Mar 2025 11:09:45 +0800

deepin-calculator (6.5.8) unstable; urgency=medium

  * Bump version to 6.5.8

 -- wangrong <wangrong@uniontech.com>  Thu, 27 Feb 2025 19:25:28 +0800

deepin-calculator (6.5.7) unstable; urgency=medium

  * Update version to 6.5.7
  * Update linglong.yaml for new base

 -- wangrong <wangrong@uniontech.com>  Tue, 18 Feb 2025 14:35:51 +0800

deepin-calculator (6.5.6) unstable; urgency=medium

  * Update version to 6.5.6

 -- wangrong <wangrong@uniontech.com>  Tue, 21 Jan 2025 16:29:23 +0800

deepin-calculator (6.5.5) unstable; urgency=medium

  * New tag

 -- Liu zheng <liuzheng@uniontech.com>  Mon, 20 Jan 2025 14:12:52 +0800

deepin-calculator (6.5.4) unstable; urgency=medium

  * chore: New version 6.5.4.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 20 Dec 2024 11:32:12 +0800

deepin-calculator (6.5.3) unstable; urgency=medium

  * Update version to 6.5.3

 -- xiepengfei <xiepengfei@uniontech.com>  Sat, 14 Dec 2024 14:40:35 +0800

deepin-calculator (6.5.2) unstable; urgency=medium

  * Update version to 6.5.2

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 18:43:55 +0800

deepin-calculator (6.5.1) unstable; urgency=medium

  * Update version to 6.5.1

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 13:49:04 +0800

deepin-calculator (6.5.0) unstable; urgency=medium

  * chore: Bump version to 6.5.0

 -- wangrong <wangrong@uniontech.com>  Wed, 16 Oct 2024 15:35:14 +0800

deepin-calculator (6.0.2) unstable; urgency=medium

  * chore: Adapt linglong.

 -- wangrong <wangrong@uniontech.com>  Sat, 12 Oct 2024 10:22:23 +0800

## deepin-calculator 6.5.16

=== debian/changelog ===
deepin-calculator (6.5.16) unstable; urgency=medium

  * bump version to 6.5.16

 -- xiepengfei <xiepengfei@uniontech.com>  Mon, 23 Jun 2025 11:41:39 +0800

deepin-calculator (6.5.15) unstable; urgency=medium

  * bump version to 6.5.15

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 18 Jun 2025 17:51:56 +0800

deepin-calculator (6.5.14) unstable; urgency=medium

  * chore: Update deepin-calculator version to 6.5.13.1 in configuration files

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 18 Jun 2025 17:06:35 +0800

deepin-calculator (6.5.13) unstable; urgency=medium

  * update damn's version

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 18 Jun 2025 16:05:27 +0800

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt6
include /usr/share/dpkg/default.mk

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DH_AUTO_ARGS = --parallel --buildsystem=cmake
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
          -DBUILD_TESTING=OFF \
      -DCMAKE_SAFETYTEST_ARG="CMAKE_SAFETYTEST_ARG_OFF" \
	  -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

## deepin-calculator 6.5.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE")
 set(QT_MINIMUM_VERSION "6.0.0")
 set(CMAKE_EXE_LINKER_FLAGS "-pie")

=== debian/changelog ===
deepin-calculator (6.5.20) unstable; urgency=medium

  * chore: Update package URLs and digests in linglong.yaml files

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 10 Jul 2025 17:07:11 +0800

deepin-calculator (6.5.19) unstable; urgency=medium

  * Update version to 6.5.19. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Thu, 03 Jul 2025 11:02:49 +0800

deepin-calculator (6.5.18) unstable; urgency=medium

  * chore: update package URLs and digests in linglong.yaml files for all architectures

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 02 Jul 2025 10:49:16 +0800

deepin-calculator (6.5.17) unstable; urgency=medium

  * update version to 6.5.17. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Tue, 01 Jul 2025 20:41:36 +0800

## deepin-calculator 6.5.24

=== debian/changelog ===
deepin-calculator (6.5.24) unstable; urgency=medium

  * chore: Update translations for Lao locale (#166)

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 13 Aug 2025 15:40:20 +0800

deepin-calculator (6.5.23) unstable; urgency=medium

  * Update version to 6.5.23. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Thu, 07 Aug 2025 17:36:15 +0800

deepin-calculator (6.5.22) unstable; urgency=medium

  * chore: update linglong source

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 01 Aug 2025 10:16:33 +0800

deepin-calculator (6.5.21) unstable; urgency=medium

  * chore: update changelog

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 31 Jul 2025 21:34:52 +0800

## deepin-calculator 6.5.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE")
 set(QT_MINIMUM_VERSION "6.0.0")
-set(CMAKE_EXE_LINKER_FLAGS "-pie")
+set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
 
 
 # Find the Qt library

=== debian/changelog ===
deepin-calculator (6.5.27) unstable; urgency=medium

  * Update version to 6.5.27. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Thu, 16 Oct 2025 19:08:12 +0800

deepin-calculator (6.5.26) unstable; urgency=medium

  * chore: Update linglong base and runtime

 -- wangrong <wangrong@uniontech.com>  Wed, 17 Sep 2025 10:18:11 +0800

deepin-calculator (6.5.25) unstable; urgency=medium

  * Update version to 6.5.25. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Wed, 27 Aug 2025 11:31:33 +0800

=== debian/control ===
Source: deepin-calculator
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends: 
    debhelper (>= 9),
    cmake,
    pkg-config,
    libdtk6gui-dev,
    libdtk6widget-dev,
    qt6-svg-dev,
    qt6-tools-dev,
    qt6-tools-dev-tools,
    libgtest-dev,
    libgmock-dev,
    qt6-base-dev,
    qt6-base-dev-tools,
    qt6-base-private-dev,
    qt6-l10n-tools
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-calculator
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Calculator for UOS
 Calculator is a simple and easy-to-use desktop calculator. It supports addition, subtraction, multiplication and division with keyboard input perfectly matched, as well as symbolic fault-tolerant computing and calculation result linkage.

## deepin-calculator 6.5.29

=== CMakeLists.txt ===
--- 
+++ 
@@ -112,7 +112,6 @@
 )
 endif()
 
-
 file(GLOB_RECURSE CAL_SRCH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)
 file(GLOB_RECURSE CAL_SRCC ${CMAKE_CURRENT_LIST_DIR}/src/*.c)
 file(GLOB_RECURSE CAL_SRCCPP ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
@@ -165,6 +164,8 @@
     FILES_MATCHING PATTERN "*.qm")
 install(FILES ${CMAKE_CURRENT_LIST_DIR}/deepin-calculator.desktop
         DESTINATION ${CMAKE_INSTALL_DATADIR}/applications/)
+install(FILES ${CMAKE_CURRENT_LIST_DIR}/com.deepin.Calculator.service
+        DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services/)
 install(FILES ${CMAKE_CURRENT_LIST_DIR}/src/assets/images/deepin-calculator.svg
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)
 install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/src/assets/deepin-calculator

=== debian/changelog ===
deepin-calculator (6.5.29) unstable; urgency=medium

  * Update version to 6.5.29.

 -- Tian ShiLin <tianshilin@uniontech.com>  Fri, 21 Nov 2025 09:52:57 +0800

deepin-calculator (6.5.28) unstable; urgency=medium

  * update version to 6.5.28

 -- Tian ShiLin <tianshilin@uniontech.com>  Thu, 30 Oct 2025 17:12:35 +0800
